import execa from 'execa';
declare type PackageMap = {
    [packageName: string]: string | undefined;
};
declare type PackageList = string[];
declare type Packages = PackageMap | PackageList;
declare type SupportedPackageManagers = 'yarn' | 'npm';
declare type StdioOption = 'pipe' | 'ignore' | 'inherit';
declare type InstallConfig = {
    prefer: SupportedPackageManagers | null;
    dev: boolean;
    exact: boolean;
    noSave: boolean;
    bundle: boolean;
    verbose: boolean;
    stdio: StdioOption | StdioOption[];
    cwd: string;
};
export declare const defaultConfig: {
    dev: boolean;
    prefer: null;
    exact: boolean;
    noSave: boolean;
    bundle: boolean;
    verbose: boolean;
    stdio: StdioOption;
    cwd: string;
};
export declare function getPackageList(packages: Packages): PackageList;
export declare function isManagerInstalled(manager: SupportedPackageManagers): Promise<boolean>;
export declare function isManagerInstalledSync(manager: SupportedPackageManagers): boolean;
export declare function getCurrentPackageManager(): SupportedPackageManagers | null;
export declare function constructYarnArguments(packageList: PackageList, config: InstallConfig): string[];
export declare function constructNpmArguments(packageList: PackageList, config: InstallConfig): string[];
export declare function getPackageManager(config: InstallConfig): Promise<SupportedPackageManagers>;
export declare function getPackageManagerSync(config: InstallConfig): SupportedPackageManagers;
export declare function install(packages: Packages, options?: Partial<InstallConfig>): Promise<execa.ExecaReturns>;
export declare function installSync(packages: PackageList, options: Partial<InstallConfig>): execa.ExecaReturns;
export {};
