"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var execa_1 = __importDefault(require("execa"));
exports.defaultConfig = {
    dev: false,
    prefer: null,
    exact: false,
    noSave: false,
    bundle: false,
    verbose: false,
    stdio: 'pipe',
    cwd: process.cwd(),
};
function getPackageList(packages) {
    if (Array.isArray(packages)) {
        return packages.filter(function (pkg) { return typeof pkg === 'string'; });
    }
    var entries = Object.entries(packages);
    return entries
        .filter(function (_a) {
        var name = _a[0], version = _a[1];
        return ((typeof name === 'string' && typeof version === 'string') ||
            typeof version === 'undefined');
    })
        .map(function (_a) {
        var name = _a[0], version = _a[1];
        return version ? name + "@" + version : name;
    });
}
exports.getPackageList = getPackageList;
function isManagerInstalled(manager) {
    return __awaiter(this, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, execa_1.default(manager, ['--version'])];
                case 1:
                    result = _a.sent();
                    return [2 /*return*/, !result.failed];
            }
        });
    });
}
exports.isManagerInstalled = isManagerInstalled;
function isManagerInstalledSync(manager) {
    var result = execa_1.default.sync(manager, ['--version']);
    return !result.failed;
}
exports.isManagerInstalledSync = isManagerInstalledSync;
function getCurrentPackageManager() {
    var userAgent = process.env.npm_config_user_agent;
    if (!userAgent) {
        return null;
    }
    if (userAgent.startsWith('npm')) {
        return 'npm';
    }
    if (userAgent.startsWith('yarn')) {
        return 'yarn';
    }
    return null;
}
exports.getCurrentPackageManager = getCurrentPackageManager;
function constructYarnArguments(packageList, config) {
    var args = ['add'].concat(packageList);
    if (config.dev) {
        args.push('--dev');
    }
    if (config.exact) {
        args.push('--exact');
    }
    if (config.verbose) {
        args.push('--verbose');
    }
    return args;
}
exports.constructYarnArguments = constructYarnArguments;
function constructNpmArguments(packageList, config) {
    var args = ['install'].concat(packageList);
    if (config.dev) {
        args.push('--save-dev');
    }
    if (config.exact) {
        args.push('--save-exact');
    }
    if (config.bundle) {
        args.push('--save-bundle');
    }
    if (config.noSave) {
        args.push('--no-save');
    }
    if (config.verbose) {
        args.push('--verbose');
    }
    return args;
}
exports.constructNpmArguments = constructNpmArguments;
function getPackageManager(config) {
    return __awaiter(this, void 0, void 0, function () {
        var pkgManager;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    pkgManager = config.prefer || getCurrentPackageManager();
                    if (!pkgManager) {
                        pkgManager = 'npm';
                    }
                    return [4 /*yield*/, isManagerInstalled(pkgManager)];
                case 1:
                    if (!!(_a.sent())) return [3 /*break*/, 3];
                    pkgManager = pkgManager === 'npm' ? 'yarn' : 'npm';
                    return [4 /*yield*/, isManagerInstalled(pkgManager)];
                case 2:
                    if (!(_a.sent())) {
                        throw new Error('No supported package manager found');
                    }
                    _a.label = 3;
                case 3: return [2 /*return*/, pkgManager];
            }
        });
    });
}
exports.getPackageManager = getPackageManager;
function getPackageManagerSync(config) {
    var pkgManager = config.prefer || getCurrentPackageManager();
    if (!pkgManager) {
        pkgManager = 'npm';
    }
    if (!isManagerInstalledSync(pkgManager)) {
        pkgManager = pkgManager === 'npm' ? 'yarn' : 'npm';
        if (!isManagerInstalledSync(pkgManager)) {
            throw new Error('No supported package manager found');
        }
    }
    return pkgManager;
}
exports.getPackageManagerSync = getPackageManagerSync;
function getExecaConfig(config) {
    return {
        stdio: config.stdio,
        cwd: config.cwd,
    };
}
function install(packages, options) {
    if (options === void 0) { options = {}; }
    return __awaiter(this, void 0, void 0, function () {
        var config, pkgManager, packageList, getArguments, args;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    config = __assign({}, exports.defaultConfig, options);
                    return [4 /*yield*/, getPackageManager(config)];
                case 1:
                    pkgManager = _a.sent();
                    packageList = getPackageList(packages);
                    getArguments = pkgManager === 'npm' ? constructNpmArguments : constructYarnArguments;
                    args = getArguments(packageList, config);
                    return [2 /*return*/, execa_1.default(pkgManager, args, getExecaConfig(config))];
            }
        });
    });
}
exports.install = install;
function installSync(packages, options) {
    var config = __assign({}, exports.defaultConfig, options);
    var pkgManager = getPackageManagerSync(config);
    var packageList = getPackageList(packages);
    var getArguments = pkgManager === 'npm' ? constructNpmArguments : constructYarnArguments;
    var args = getArguments(packageList, config);
    return execa_1.default.sync(pkgManager, args, getExecaConfig(config));
}
exports.installSync = installSync;
//# sourceMappingURL=index.js.map